# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'GetKeyspacesResult',
    'AwaitableGetKeyspacesResult',
    'get_keyspaces',
    'get_keyspaces_output',
]

@pulumi.output_type
class GetKeyspacesResult:
    """
    A collection of values returned by getKeyspaces.
    """
    def __init__(__self__, database_id=None, id=None, results=None):
        if database_id and not isinstance(database_id, str):
            raise TypeError("Expected argument 'database_id' to be a str")
        pulumi.set(__self__, "database_id", database_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if results and not isinstance(results, list):
            raise TypeError("Expected argument 'results' to be a list")
        pulumi.set(__self__, "results", results)

    @property
    @pulumi.getter(name="databaseId")
    def database_id(self) -> str:
        """
        The ID of the Astra database.
        """
        return pulumi.get(self, "database_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def results(self) -> Sequence['outputs.GetKeyspacesResultResult']:
        """
        The list of keyspaces that match the search criteria.
        """
        return pulumi.get(self, "results")


class AwaitableGetKeyspacesResult(GetKeyspacesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetKeyspacesResult(
            database_id=self.database_id,
            id=self.id,
            results=self.results)


def get_keyspaces(database_id: Optional[str] = None,
                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetKeyspacesResult:
    """
    `get_keyspaces` provides a datasource that lists the keyspaces in an Astra database.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_astra as astra

    dev = astra.get_keyspaces(database_id="f9f4b1e0-4c05-451e-9bba-d631295a7f73")
    ```


    :param str database_id: The ID of the Astra database.
    """
    __args__ = dict()
    __args__['databaseId'] = database_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('astra:index/getKeyspaces:getKeyspaces', __args__, opts=opts, typ=GetKeyspacesResult).value

    return AwaitableGetKeyspacesResult(
        database_id=__ret__.database_id,
        id=__ret__.id,
        results=__ret__.results)


@_utilities.lift_output_func(get_keyspaces)
def get_keyspaces_output(database_id: Optional[pulumi.Input[str]] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetKeyspacesResult]:
    """
    `get_keyspaces` provides a datasource that lists the keyspaces in an Astra database.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_astra as astra

    dev = astra.get_keyspaces(database_id="f9f4b1e0-4c05-451e-9bba-d631295a7f73")
    ```


    :param str database_id: The ID of the Astra database.
    """
    ...
