# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetRoleResult',
    'AwaitableGetRoleResult',
    'get_role',
    'get_role_output',
]

@pulumi.output_type
class GetRoleResult:
    """
    A collection of values returned by getRole.
    """
    def __init__(__self__, description=None, effect=None, id=None, policies=None, resources=None, role_id=None, role_name=None):
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if effect and not isinstance(effect, str):
            raise TypeError("Expected argument 'effect' to be a str")
        pulumi.set(__self__, "effect", effect)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if policies and not isinstance(policies, list):
            raise TypeError("Expected argument 'policies' to be a list")
        pulumi.set(__self__, "policies", policies)
        if resources and not isinstance(resources, list):
            raise TypeError("Expected argument 'resources' to be a list")
        pulumi.set(__self__, "resources", resources)
        if role_id and not isinstance(role_id, str):
            raise TypeError("Expected argument 'role_id' to be a str")
        pulumi.set(__self__, "role_id", role_id)
        if role_name and not isinstance(role_name, str):
            raise TypeError("Expected argument 'role_name' to be a str")
        pulumi.set(__self__, "role_name", role_name)

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Role description
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def effect(self) -> str:
        """
        Role effect
        """
        return pulumi.get(self, "effect")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def policies(self) -> Sequence[str]:
        """
        List of policies for the role. See https://docs.datastax.com/en/astra/docs/user-permissions.html#*operational*roles_detail for supported policies.
        """
        return pulumi.get(self, "policies")

    @property
    @pulumi.getter
    def resources(self) -> Sequence[str]:
        """
        Resources for which role is applicable (format is "drn:astra:org:\\n\\n", followed by optional resource criteria. See example usage above).
        """
        return pulumi.get(self, "resources")

    @property
    @pulumi.getter(name="roleId")
    def role_id(self) -> str:
        """
        Role ID, system generated
        """
        return pulumi.get(self, "role_id")

    @property
    @pulumi.getter(name="roleName")
    def role_name(self) -> str:
        """
        Role name
        """
        return pulumi.get(self, "role_name")


class AwaitableGetRoleResult(GetRoleResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRoleResult(
            description=self.description,
            effect=self.effect,
            id=self.id,
            policies=self.policies,
            resources=self.resources,
            role_id=self.role_id,
            role_name=self.role_name)


def get_role(role_id: Optional[str] = None,
             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRoleResult:
    """
    `Role` provides a datasource that lists the custom roles for an org.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_astra as astra

    dev = astra.get_role(role_id="role-id-here")
    ```


    :param str role_id: Role ID, system generated
    """
    __args__ = dict()
    __args__['roleId'] = role_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('astra:index/getRole:getRole', __args__, opts=opts, typ=GetRoleResult).value

    return AwaitableGetRoleResult(
        description=__ret__.description,
        effect=__ret__.effect,
        id=__ret__.id,
        policies=__ret__.policies,
        resources=__ret__.resources,
        role_id=__ret__.role_id,
        role_name=__ret__.role_name)


@_utilities.lift_output_func(get_role)
def get_role_output(role_id: Optional[pulumi.Input[str]] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetRoleResult]:
    """
    `Role` provides a datasource that lists the custom roles for an org.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_astra as astra

    dev = astra.get_role(role_id="role-id-here")
    ```


    :param str role_id: Role ID, system generated
    """
    ...
