# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'AccessListAddress',
    'GetAccessListAddressResult',
    'GetAstraDatabasesResultResult',
    'GetAvailableRegionsResultResult',
    'GetKeyspacesResultResult',
    'GetPrivateLinkEndpointsResultResult',
    'GetPrivateLinksResultResult',
    'GetRolesResultResult',
    'GetSecureConnectBundleUrlSecureBundleResult',
    'GetSecureConnectBundleUrlSecureBundleCustomDomainBundleResult',
    'GetStreamingTenantTokensTokenResult',
    'GetUsersUserResult',
    'GetUsersUserRoleResult',
]

@pulumi.output_type
class AccessListAddress(dict):
    def __init__(__self__, *,
                 address: str,
                 enabled: bool,
                 description: Optional[str] = None):
        """
        :param str address: IP Address/CIDR group that should have access
        :param bool enabled: Enable/disable this IP Address/CIDR group's access
        :param str description: Description for the IP Address/CIDR group
        """
        pulumi.set(__self__, "address", address)
        pulumi.set(__self__, "enabled", enabled)
        if description is not None:
            pulumi.set(__self__, "description", description)

    @property
    @pulumi.getter
    def address(self) -> str:
        """
        IP Address/CIDR group that should have access
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter
    def enabled(self) -> bool:
        """
        Enable/disable this IP Address/CIDR group's access
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        Description for the IP Address/CIDR group
        """
        return pulumi.get(self, "description")


@pulumi.output_type
class GetAccessListAddressResult(dict):
    def __init__(__self__, *,
                 address: str,
                 enabled: bool,
                 description: Optional[str] = None):
        """
        :param bool enabled: The Access list is enabled or disabled.
        """
        pulumi.set(__self__, "address", address)
        pulumi.set(__self__, "enabled", enabled)
        if description is not None:
            pulumi.set(__self__, "description", description)

    @property
    @pulumi.getter
    def address(self) -> str:
        return pulumi.get(self, "address")

    @property
    @pulumi.getter
    def enabled(self) -> bool:
        """
        The Access list is enabled or disabled.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        return pulumi.get(self, "description")


@pulumi.output_type
class GetAstraDatabasesResultResult(dict):
    def __init__(__self__, *,
                 additional_keyspaces: Sequence[str],
                 cloud_provider: str,
                 cqlsh_url: str,
                 data_endpoint_url: str,
                 datacenters: Mapping[str, str],
                 grafana_url: str,
                 graphql_url: str,
                 id: str,
                 keyspace: str,
                 name: str,
                 node_count: int,
                 organization_id: str,
                 owner_id: str,
                 regions: Sequence[str],
                 replication_factor: int,
                 status: str,
                 total_storage: int):
        """
        :param str cloud_provider: The cloud provider
        :param str id: The ID of this resource.
        :param str status: Status flter. Only return databases with matching status, if supplied. Otherwise return all databases matching other requirements
        """
        pulumi.set(__self__, "additional_keyspaces", additional_keyspaces)
        pulumi.set(__self__, "cloud_provider", cloud_provider)
        pulumi.set(__self__, "cqlsh_url", cqlsh_url)
        pulumi.set(__self__, "data_endpoint_url", data_endpoint_url)
        pulumi.set(__self__, "datacenters", datacenters)
        pulumi.set(__self__, "grafana_url", grafana_url)
        pulumi.set(__self__, "graphql_url", graphql_url)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "keyspace", keyspace)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "node_count", node_count)
        pulumi.set(__self__, "organization_id", organization_id)
        pulumi.set(__self__, "owner_id", owner_id)
        pulumi.set(__self__, "regions", regions)
        pulumi.set(__self__, "replication_factor", replication_factor)
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "total_storage", total_storage)

    @property
    @pulumi.getter(name="additionalKeyspaces")
    def additional_keyspaces(self) -> Sequence[str]:
        return pulumi.get(self, "additional_keyspaces")

    @property
    @pulumi.getter(name="cloudProvider")
    def cloud_provider(self) -> str:
        """
        The cloud provider
        """
        return pulumi.get(self, "cloud_provider")

    @property
    @pulumi.getter(name="cqlshUrl")
    def cqlsh_url(self) -> str:
        return pulumi.get(self, "cqlsh_url")

    @property
    @pulumi.getter(name="dataEndpointUrl")
    def data_endpoint_url(self) -> str:
        return pulumi.get(self, "data_endpoint_url")

    @property
    @pulumi.getter
    def datacenters(self) -> Mapping[str, str]:
        return pulumi.get(self, "datacenters")

    @property
    @pulumi.getter(name="grafanaUrl")
    def grafana_url(self) -> str:
        return pulumi.get(self, "grafana_url")

    @property
    @pulumi.getter(name="graphqlUrl")
    def graphql_url(self) -> str:
        return pulumi.get(self, "graphql_url")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of this resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def keyspace(self) -> str:
        return pulumi.get(self, "keyspace")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nodeCount")
    def node_count(self) -> int:
        return pulumi.get(self, "node_count")

    @property
    @pulumi.getter(name="organizationId")
    def organization_id(self) -> str:
        return pulumi.get(self, "organization_id")

    @property
    @pulumi.getter(name="ownerId")
    def owner_id(self) -> str:
        return pulumi.get(self, "owner_id")

    @property
    @pulumi.getter
    def regions(self) -> Sequence[str]:
        return pulumi.get(self, "regions")

    @property
    @pulumi.getter(name="replicationFactor")
    def replication_factor(self) -> int:
        return pulumi.get(self, "replication_factor")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        Status flter. Only return databases with matching status, if supplied. Otherwise return all databases matching other requirements
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="totalStorage")
    def total_storage(self) -> int:
        return pulumi.get(self, "total_storage")


@pulumi.output_type
class GetAvailableRegionsResultResult(dict):
    def __init__(__self__, *,
                 cloud_provider: str,
                 display_name: str,
                 region: str,
                 zone: str):
        pulumi.set(__self__, "cloud_provider", cloud_provider)
        pulumi.set(__self__, "display_name", display_name)
        pulumi.set(__self__, "region", region)
        pulumi.set(__self__, "zone", zone)

    @property
    @pulumi.getter(name="cloudProvider")
    def cloud_provider(self) -> str:
        return pulumi.get(self, "cloud_provider")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> str:
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def zone(self) -> str:
        return pulumi.get(self, "zone")


@pulumi.output_type
class GetKeyspacesResultResult(dict):
    def __init__(__self__, *,
                 name: str):
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")


@pulumi.output_type
class GetPrivateLinkEndpointsResultResult(dict):
    def __init__(__self__, *,
                 create_time: str,
                 description: str,
                 endpoint_id: str,
                 status: str):
        """
        :param str endpoint_id: Endpoint ID.
        """
        pulumi.set(__self__, "create_time", create_time)
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "endpoint_id", endpoint_id)
        pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter
    def description(self) -> str:
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="endpointId")
    def endpoint_id(self) -> str:
        """
        Endpoint ID.
        """
        return pulumi.get(self, "endpoint_id")

    @property
    @pulumi.getter
    def status(self) -> str:
        return pulumi.get(self, "status")


@pulumi.output_type
class GetPrivateLinksResultResult(dict):
    def __init__(__self__, *,
                 allowed_principals: Sequence[str],
                 datacenter_id: str,
                 endpoints: Sequence[str],
                 service_name: str):
        """
        :param str datacenter_id: The datacenter where of the Astra database.
        """
        pulumi.set(__self__, "allowed_principals", allowed_principals)
        pulumi.set(__self__, "datacenter_id", datacenter_id)
        pulumi.set(__self__, "endpoints", endpoints)
        pulumi.set(__self__, "service_name", service_name)

    @property
    @pulumi.getter(name="allowedPrincipals")
    def allowed_principals(self) -> Sequence[str]:
        return pulumi.get(self, "allowed_principals")

    @property
    @pulumi.getter(name="datacenterId")
    def datacenter_id(self) -> str:
        """
        The datacenter where of the Astra database.
        """
        return pulumi.get(self, "datacenter_id")

    @property
    @pulumi.getter
    def endpoints(self) -> Sequence[str]:
        return pulumi.get(self, "endpoints")

    @property
    @pulumi.getter(name="serviceName")
    def service_name(self) -> str:
        return pulumi.get(self, "service_name")


@pulumi.output_type
class GetRolesResultResult(dict):
    def __init__(__self__, *,
                 description: str,
                 effect: str,
                 policies: Sequence[str],
                 resources: Sequence[str],
                 role_id: str,
                 role_name: str):
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "effect", effect)
        pulumi.set(__self__, "policies", policies)
        pulumi.set(__self__, "resources", resources)
        pulumi.set(__self__, "role_id", role_id)
        pulumi.set(__self__, "role_name", role_name)

    @property
    @pulumi.getter
    def description(self) -> str:
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def effect(self) -> str:
        return pulumi.get(self, "effect")

    @property
    @pulumi.getter
    def policies(self) -> Sequence[str]:
        return pulumi.get(self, "policies")

    @property
    @pulumi.getter
    def resources(self) -> Sequence[str]:
        return pulumi.get(self, "resources")

    @property
    @pulumi.getter(name="roleId")
    def role_id(self) -> str:
        return pulumi.get(self, "role_id")

    @property
    @pulumi.getter(name="roleName")
    def role_name(self) -> str:
        return pulumi.get(self, "role_name")


@pulumi.output_type
class GetSecureConnectBundleUrlSecureBundleResult(dict):
    def __init__(__self__, *,
                 custom_domain_bundles: Sequence['outputs.GetSecureConnectBundleUrlSecureBundleCustomDomainBundleResult'],
                 datacenter_id: str,
                 internal_migration_proxy_url: str,
                 internal_url: str,
                 migration_proxy_url: str,
                 url: str):
        """
        :param str datacenter_id: The ID of the Astra datacenter. If omitted, all bundles will be fetched.
        """
        pulumi.set(__self__, "custom_domain_bundles", custom_domain_bundles)
        pulumi.set(__self__, "datacenter_id", datacenter_id)
        pulumi.set(__self__, "internal_migration_proxy_url", internal_migration_proxy_url)
        pulumi.set(__self__, "internal_url", internal_url)
        pulumi.set(__self__, "migration_proxy_url", migration_proxy_url)
        pulumi.set(__self__, "url", url)

    @property
    @pulumi.getter(name="customDomainBundles")
    def custom_domain_bundles(self) -> Sequence['outputs.GetSecureConnectBundleUrlSecureBundleCustomDomainBundleResult']:
        return pulumi.get(self, "custom_domain_bundles")

    @property
    @pulumi.getter(name="datacenterId")
    def datacenter_id(self) -> str:
        """
        The ID of the Astra datacenter. If omitted, all bundles will be fetched.
        """
        return pulumi.get(self, "datacenter_id")

    @property
    @pulumi.getter(name="internalMigrationProxyUrl")
    def internal_migration_proxy_url(self) -> str:
        return pulumi.get(self, "internal_migration_proxy_url")

    @property
    @pulumi.getter(name="internalUrl")
    def internal_url(self) -> str:
        return pulumi.get(self, "internal_url")

    @property
    @pulumi.getter(name="migrationProxyUrl")
    def migration_proxy_url(self) -> str:
        return pulumi.get(self, "migration_proxy_url")

    @property
    @pulumi.getter
    def url(self) -> str:
        return pulumi.get(self, "url")


@pulumi.output_type
class GetSecureConnectBundleUrlSecureBundleCustomDomainBundleResult(dict):
    def __init__(__self__, *,
                 api_fqdn: str,
                 cql_fqdn: str,
                 dashboard_fqdn: str,
                 domain: str,
                 url: str):
        pulumi.set(__self__, "api_fqdn", api_fqdn)
        pulumi.set(__self__, "cql_fqdn", cql_fqdn)
        pulumi.set(__self__, "dashboard_fqdn", dashboard_fqdn)
        pulumi.set(__self__, "domain", domain)
        pulumi.set(__self__, "url", url)

    @property
    @pulumi.getter(name="apiFqdn")
    def api_fqdn(self) -> str:
        return pulumi.get(self, "api_fqdn")

    @property
    @pulumi.getter(name="cqlFqdn")
    def cql_fqdn(self) -> str:
        return pulumi.get(self, "cql_fqdn")

    @property
    @pulumi.getter(name="dashboardFqdn")
    def dashboard_fqdn(self) -> str:
        return pulumi.get(self, "dashboard_fqdn")

    @property
    @pulumi.getter
    def domain(self) -> str:
        return pulumi.get(self, "domain")

    @property
    @pulumi.getter
    def url(self) -> str:
        return pulumi.get(self, "url")


@pulumi.output_type
class GetStreamingTenantTokensTokenResult(dict):
    def __init__(__self__, *,
                 iat: int,
                 iss: str,
                 sub: str,
                 token: str,
                 token_id: str):
        pulumi.set(__self__, "iat", iat)
        pulumi.set(__self__, "iss", iss)
        pulumi.set(__self__, "sub", sub)
        pulumi.set(__self__, "token", token)
        pulumi.set(__self__, "token_id", token_id)

    @property
    @pulumi.getter
    def iat(self) -> int:
        return pulumi.get(self, "iat")

    @property
    @pulumi.getter
    def iss(self) -> str:
        return pulumi.get(self, "iss")

    @property
    @pulumi.getter
    def sub(self) -> str:
        return pulumi.get(self, "sub")

    @property
    @pulumi.getter
    def token(self) -> str:
        return pulumi.get(self, "token")

    @property
    @pulumi.getter(name="tokenId")
    def token_id(self) -> str:
        return pulumi.get(self, "token_id")


@pulumi.output_type
class GetUsersUserResult(dict):
    def __init__(__self__, *,
                 email: str,
                 roles: Sequence['outputs.GetUsersUserRoleResult'],
                 status: str,
                 user_id: str):
        pulumi.set(__self__, "email", email)
        pulumi.set(__self__, "roles", roles)
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "user_id", user_id)

    @property
    @pulumi.getter
    def email(self) -> str:
        return pulumi.get(self, "email")

    @property
    @pulumi.getter
    def roles(self) -> Sequence['outputs.GetUsersUserRoleResult']:
        return pulumi.get(self, "roles")

    @property
    @pulumi.getter
    def status(self) -> str:
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="userId")
    def user_id(self) -> str:
        return pulumi.get(self, "user_id")


@pulumi.output_type
class GetUsersUserRoleResult(dict):
    def __init__(__self__, *,
                 role_id: str):
        pulumi.set(__self__, "role_id", role_id)

    @property
    @pulumi.getter(name="roleId")
    def role_id(self) -> str:
        return pulumi.get(self, "role_id")


